<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=utf-8">
<title>zh/HowTos/CommunityBuildSystem</title>
<link rel="stylesheet" type="text/css" media="all" charset="utf-8" href="modern/css/common.css">
<link rel="stylesheet" type="text/css" media="screen" charset="utf-8" href="modern/css/screen.css">
<link rel="stylesheet" type="text/css" media="print" charset="utf-8" href="modern/css/print.css">
<style type="text/css">
ul.pagetitle{
  display: inline;
  margin: 0;
  padding: 0;
  font-size: 1.5em;
}
li.pagetitle{
  display: inline;
  margin: 0;
}
td.noborder {
  border: 0;
}
</style>
</head>
<body>
<table>
<tr>
<td class="noborder">
<img src="logo.png">
</td>
<td class="noborder">
<ul class="pagetitle">
<li class="pagetitle"><a class="backlink">zh/HowTos/CommunityBuildSystem</a>
</ul>
<br><br>
[<a href="FrontPage.html">FrontPage</a>]&nbsp;[<a href="TitleIndex.html">TitleIndex</a>]&nbsp;[<a href="WordIndex.html">WordIndex</a>]&nbsp;
</td>
</tr>
</table>
<hr>
<div id="page"><h1 style="background-color:Red; color:White">This is a read-only <a href="https://gitlab.com/CentOS/docs/wiki_archives">archived version</a> of wiki.centos.org</h1>
<div dir="ltr" id="content" lang="zh"><span class="anchor" id="top"></span>
<span class="anchor" id="line-1"></span><span class="anchor" id="line-2"></span><span class="anchor" id="line-3"></span><p class="line867"><div class="table-of-contents"><p class="table-of-contents-heading">Contents<ol><li>
<a href="#A.2BbOhRjE4ATiqNJlP3-">注册一个账号</a></li><li>
<a href="#A.2Bg7dfl14uUqk-">获得帮助</a></li><li>
<a href="#A.2BTjRl9l76i74-">临时建设</a></li><li>
<a href="#A.2BaAdRxl76i74-">标准建设</a></li><li>
<a href="#A.2BXAZzsGcJdoRe.2Bou.2BUqCP204ATipoB3t.2BUYU-">将现有的建设加进一个标签内</a></li><li>
<a href="#Git_.2BXvqLvg-">Git 建设</a></li><li>
<a href="#A.2BWVdO9l3yg7de.2BnrL-">套件已获建立</a></li><li>
<a href="#A.2BXfKPx2cfUe2LwQ-">已过期凭证</a></li><li>
<a href="#A.2Bkcd1KF3yj8dl9naE_SSLv3">采用已过时的 SSLv3</a></li><li>
<a href="#A.2BXpR1KFkaTio_koji_.2BW55Piw-">应用多个 koji 实例</a></li></ol></li></ol></div> <span class="anchor" id="line-4"></span><span class="anchor" id="line-5"></span><p class="line867">
<h1 id="A.2BeT5.2FpF76i758.2B37f-">社群建设系统</h1>
<span class="anchor" id="line-6"></span><span class="anchor" id="line-7"></span><p class="line867"><a class="http" href="http://cbs.centos.org/">CBS</a> 是供<a href="./zh(2f)SpecialInterestGroup.html">特别兴趣小组</a>成员用的社群建设系统。 <span class="anchor" id="line-8"></span><span class="anchor" id="line-9"></span><p class="line867">
<h1 id="A.2BX.2BuQH1Flleg-">快速入门</h1>
<span class="anchor" id="line-10"></span><span class="anchor" id="line-11"></span><p class="line867">
<h2 id="A.2BbOhRjE4ATiqNJlP3-">1. 注册一个账号</h2>
<span class="anchor" id="line-12"></span><ol type="1"><li><p class="line862">访问 <a class="https" href="https://accounts.centos.org">账号系统</a> <span class="anchor" id="line-13"></span></li><li>选择 '新账号' <span class="anchor" id="line-14"></span></li><li>用你的信息填写完表格 <span class="anchor" id="line-15"></span></li><li>在SIG小组内申请成为你所希望成为的成员 <span class="anchor" id="line-16"></span><span class="anchor" id="line-17"></span><ul><li><p class="line862">每周一，在<a class="https" href="https://www.centos.org/community/calendar#community-buildsystem-infrastructure-meeting">CBS 会议</a>之前，管理员会和SIG成员一起敲定保荐申请 <span class="anchor" id="line-18"></span></li></ul></li><li><p class="line862">当被批准后，你需要安装客户端工具并生成你的SSL证书。更多信息参见 <a href="./zh(2f)HowTos(2f)CentosPackager.html">zh/HowTos/CentosPackager</a>。 <span class="anchor" id="line-19"></span></li><li><p class="line862">执行<tt>cbs&nbsp;moshimoshi</tt>后你应该能在应答里看到你的用户名。 <span class="anchor" id="line-20"></span></li><li><p class="line862">意外收获：<a class="https" href="https://github.com/rnc/brew-koji">Github</a> 为 zsh 及 bash 用户提供（非官方的）自动填充功能（请留意 bash 的填充功能已获更新，zsh 的较旧。明白吗？） <span class="anchor" id="line-21"></span><span class="anchor" id="line-22"></span></li></ol><p class="line867">
<h2 id="A.2Bg7dfl14uUqk-">2. 获得帮助</h2>
<span class="anchor" id="line-23"></span><p class="line874">如果你有关于CBS的问题，有许多方式可以获得帮助： <span class="anchor" id="line-24"></span><ul><li>在freenode的IRC网络上加入 #centos-devel <span class="anchor" id="line-25"></span></li><li><p class="line862">向 <a class="mailto" href="mailto:centos-devel@centos.org">centos-devel@centos.org</a> 邮件列表发送一条信息 <span class="anchor" id="line-26"></span></li><li><p class="line862">在 <a class="https" href="https://bugs.centos.org">https://bugs.centos.org</a>（项目：Buildsys，类别：community buildsys）发送一个bug <span class="anchor" id="line-27"></span><span class="anchor" id="line-28"></span></li></ul><p class="line867">
<h1 id="RPM_.2BUh1z7Q-">RPM 初班</h1>
<span class="anchor" id="line-29"></span><ul><li>RPM 术语的快速回顾： <span class="anchor" id="line-30"></span><span class="anchor" id="line-31"></span></li></ul><p class="line874">{{{SRPM=ksh-20120801-10.el6.4.src.rpm <span class="anchor" id="line-32"></span>NAME=ksh <span class="anchor" id="line-33"></span>VERSION=20120801 <span class="anchor" id="line-34"></span>RELEASE=10.el6.4 <span class="anchor" id="line-35"></span>DISTTAG=el6 <span class="anchor" id="line-36"></span>}}} <span class="anchor" id="line-37"></span><span class="anchor" id="line-38"></span><p class="line867">
<h1 id="Koji_.2BUh1z7Q-">Koji 初班</h1>
<span class="anchor" id="line-39"></span><span class="anchor" id="line-40"></span><p class="line874">Koji 有数个必须掌握的基本概念： <span class="anchor" id="line-41"></span><ul><li><p class="line862">标签（tag）：它可以是一个 buildroot 定义标签（&lt;小组名称&gt;&lt;主要版本&gt;-&lt;专案&gt;-&lt;专案发行本&gt;-&lt;标签&gt;-build、storage7-gluster-37-el7-build），或者是一个目标标签（&lt;小组名称&gt;&lt;主要版本&gt;-&lt;专案&gt;-&lt;专案发行本&gt;-release 或 &lt;小组名称&gt;&lt;主要版本&gt;-&lt;专案&gt;-&lt;专案发行本&gt;-testing）。 <span class="anchor" id="line-42"></span><span class="anchor" id="line-43"></span></li><li class="gap">目标（target）：它把一个 buildroot 定义标签联系到一个目标标签。 <span class="anchor" id="line-44"></span><ul><li style="list-style-type:none">当你创建 srpm 时，该目标便会被应用在命令行。 <span class="anchor" id="line-45"></span><p class="line862">根据预先设置，所有成功创建的组件都会被令名为 &lt;小组名称&gt;&lt;主要版本&gt;-&lt;专案&gt;-&lt;专案发行本&gt;-testing。 <span class="anchor" id="line-46"></span><span class="anchor" id="line-47"></span><p class="line862">每个目标在 CBS 内都采用 &lt;小组名称&gt;&lt;主要版本&gt;-&lt;专案&gt;-&lt;专案发行本&gt;-&lt;发行标签&gt; 这个结构，如：virt6-xen-44-el6 、storage7-gluster-37-el7、storage7-gluster-37-el7.centos、等…… <span class="anchor" id="line-48"></span><span class="anchor" id="line-49"></span></li></ul></li><li class="gap">组件（package）：源码 rpm 的名称。例如：ksh-20120801-10.el6.4.src.rpm <span class="anchor" id="line-50"></span><span class="anchor" id="line-51"></span></li><li class="gap">被创建的组件：这泛指 koji 创建的文件，例如：ksh-20120801-10.el6_5.4.rpm、ksh-20120801-10.el6.4-devel.rpm、等…… <span class="anchor" id="line-52"></span><span class="anchor" id="line-53"></span></li><li class="gap">进行标签：你可以把建设环境联系到不同的目标标签。譬如在 CBS 的工作流程中，你可以通过标签把组件从 -testing 提升至 -release。 <span class="anchor" id="line-54"></span><span class="anchor" id="line-55"></span></li></ul><p class="line867">
<h1 id="A.2BUil1KA_CBS_.2Bj9uITF76i74-">利用 CBS 进行建设</h1>
<span class="anchor" id="line-56"></span><span class="anchor" id="line-57"></span><p class="line874">以下文档假设有一个名为 bananas 的特别兴趣小组。请用你的特别兴趣小组名称来取替，但我们已创建了 bananas 标签作为测试场地，让你可进行试验。 <span class="anchor" id="line-58"></span><span class="anchor" id="line-59"></span><p class="line867">
<h2 id="A.2BTjRl9l76i74-">1. 临时建设</h2>
<span class="anchor" id="line-60"></span><span class="anchor" id="line-61"></span><p class="line874">Koji 提供一个选项让你可运用任何目标创建临时的组件。 <span class="anchor" id="line-62"></span><span class="anchor" id="line-63"></span><span class="anchor" id="line-64"></span><pre><span class="anchor" id="line-1"></span>    cbs build --scratch bananas6-el6 ksh-20120801-10.el6.4.src.rpm</pre><span class="anchor" id="line-65"></span><span class="anchor" id="line-66"></span><p class="line867">
<h2 id="A.2BaAdRxl76i74-">2. 标准建设</h2>
<span class="anchor" id="line-67"></span><ul><li>创建新组件的第一步，就是为组件加入你所需的目标标签 <span class="anchor" id="line-68"></span></li></ul><p class="line867"><span class="anchor" id="line-69"></span><span class="anchor" id="line-70"></span><span class="anchor" id="line-71"></span><pre><span class="anchor" id="line-1-1"></span>   cbs add-pkg --owner "username" bananas6-testing ksh
<span class="anchor" id="line-2"></span>   cbs add-pkg --owner "username" bananas6-release ksh</pre><span class="anchor" id="line-72"></span><p class="line874">这个动作必须为每个特别兴趣小组的每个组件进行一次。 <span class="anchor" id="line-73"></span><span class="anchor" id="line-74"></span><ul><li>然后你可以开始进行建设： <span class="anchor" id="line-75"></span></li></ul><p class="line867"><span class="anchor" id="line-76"></span><span class="anchor" id="line-77"></span><pre><span class="anchor" id="line-1-2"></span>   cbs build bananas6-el6 ksh-20120801-10.el6.4.src.rpm</pre><span class="anchor" id="line-78"></span><span class="anchor" id="line-79"></span><p class="line867">
<h2 id="A.2BXAZzsGcJdoRe.2Bou.2BUqCP204ATipoB3t.2BUYU-">3. 将现有的建设加进一个标签内</h2>
<span class="anchor" id="line-80"></span><span class="anchor" id="line-81"></span><p class="line874">有时，你想建设一个组件但收到如下的错误消息： <span class="anchor" id="line-82"></span><span class="anchor" id="line-83"></span><span class="anchor" id="line-84"></span><pre><span class="anchor" id="line-1-3"></span>GenericError: Build already exists (id=1231, state=COMPLETE): {'name': '$pkgname'..... lot of details ....}</pre><span class="anchor" id="line-85"></span><span class="anchor" id="line-86"></span><p class="line874">意思就是你已经将组件加进一个目的标签（利用 cbs add-pkg 指令，见上文），但当你尝试建设该组件时，koji 已用同一个 NVR 建设它，或许是在另一个标签下。 <span class="anchor" id="line-87"></span>因此，koji 拒绝建设它，因为 koji 不会重新建设拥有同一 NVR 的组件。 <span class="anchor" id="line-88"></span>简单的建决方法就是「标签」该建设，让它自动出现在你的标签库内。 <span class="anchor" id="line-89"></span>假设该组件的名称是 yaml-cpp，而你已经建设了 yamp-cpp-0.5.1-6.el7（你可利用 koji 的寻找功能检查它是由谁创建，及拥有什么标签）。 <span class="anchor" id="line-90"></span><span class="anchor" id="line-91"></span><span class="anchor" id="line-92"></span><pre><span class="anchor" id="line-1-4"></span>cbs tag-build bananas7-testing yaml-cpp-0.5.1-6.el7</pre><span class="anchor" id="line-93"></span><span class="anchor" id="line-94"></span><p class="line874">Kojira 将会重建软件库数据，并加入已建设的组件。 <span class="anchor" id="line-95"></span><span class="anchor" id="line-96"></span><p class="line867">
<h2 id="Git_.2BXvqLvg-">4. Git 建设</h2>
<span class="anchor" id="line-97"></span><span class="anchor" id="line-98"></span><p class="line874">一个简单的例子： <span class="anchor" id="line-99"></span><span class="anchor" id="line-100"></span><span class="anchor" id="line-101"></span><span class="anchor" id="line-102"></span><span class="anchor" id="line-103"></span><pre><span class="anchor" id="line-1-5"></span> cbs add-pkg --owner "username" bananas7-testing tzdata
<span class="anchor" id="line-2-1"></span> cbs add-pkg --owner "username" bananas7-release tzdata
<span class="anchor" id="line-3"></span> cbs build bananas7-el7 "git+https://git.centos.org/git/rpms/tzdata.git?#e24d98"</pre><span class="anchor" id="line-104"></span><span class="anchor" id="line-105"></span><p class="line867">
<h1 id="A.2BXjiJwZUZi.2B9P4WBv-">常见错误信息</h1>
<span class="anchor" id="line-106"></span><span class="anchor" id="line-107"></span><span class="anchor" id="line-108"></span><p class="line867">
<h2 id="A.2BWVdO9l3yg7de.2BnrL-">1. 套件已获建立</h2>
<span class="anchor" id="line-109"></span><span class="anchor" id="line-110"></span><p class="line867"><span class="anchor" id="line-111"></span><span class="anchor" id="line-112"></span><pre><span class="anchor" id="line-1-6"></span>GenericError: Build already exists</pre><span class="anchor" id="line-113"></span><span class="anchor" id="line-114"></span><p class="line874">见上文有关「将现有的建设加进一个标签内」的段落。 <span class="anchor" id="line-115"></span><span class="anchor" id="line-116"></span><p class="line867">
<h2 id="A.2BXfKPx2cfUe2LwQ-">2. 已过期凭证</h2>
<span class="anchor" id="line-117"></span><span class="anchor" id="line-118"></span><p class="line874">要是你看见这个错误信息： <span class="anchor" id="line-119"></span><span class="anchor" id="line-120"></span><span class="anchor" id="line-121"></span><pre><span class="anchor" id="line-1-7"></span>"Error: [('SSL routines','SSL_shutdown', 'shutdown while in init')]</pre><span class="anchor" id="line-122"></span><p class="line874">有可能你的 ~/.centos.cert x509 凭证已过期。你可以利用以下指令确定： <span class="anchor" id="line-123"></span><span class="anchor" id="line-124"></span><span class="anchor" id="line-125"></span><pre><span class="anchor" id="line-1-8"></span>openssl x509 -in ~/.centos.cert -noout -text|grep "Not After"</pre><span class="anchor" id="line-126"></span><span class="anchor" id="line-127"></span><p class="line862">如果它已过期，你只须（按照 <a class="https" href="https://wiki.centos.org/zh/HowTos/CentosPackager">https://wiki.centos.org/zh/HowTos/CentosPackager</a> 内的第 2 步）利用 centos-cert 建立新的凭证便可以了。 <span class="anchor" id="line-128"></span><span class="anchor" id="line-129"></span><p class="line867">
<h2 id="A.2Bkcd1KF3yj8dl9naE_SSLv3">3. 采用已过时的 SSLv3</h2>
<span class="anchor" id="line-130"></span><span class="anchor" id="line-131"></span><p class="line874">要是你看见这个错误信息： <span class="anchor" id="line-132"></span><span class="anchor" id="line-133"></span><span class="anchor" id="line-134"></span><pre><span class="anchor" id="line-1-9"></span>Error: [('SSL routines', 'SSL3_READ_BYTES', 'sslv3 alert handshake failure'), ('SSL routines', 'SSL3_WRITE_BYTES', 'ssl handshake failure')]</pre><span class="anchor" id="line-135"></span><span class="anchor" id="line-136"></span><p class="line862">那么你需要<a class="http" href="http://lists.centos.org/pipermail/centos-announce/2014-October/020682.html">以手动方式修正</a>你的 koji 实例，以 TLSv1 替代 SSLv3（已证实不安全）。 <span class="anchor" id="line-137"></span><span class="anchor" id="line-138"></span><p class="line867">
<h1 id="A.2Bmth.2Bp4u.2Bf24-">高级设置</h1>
<span class="anchor" id="line-139"></span><span class="anchor" id="line-140"></span><p class="line867">
<h2 id="A.2BXpR1KFkaTio_koji_.2BW55Piw-">1. 应用多个 koji 实例</h2>
<span class="anchor" id="line-141"></span><span class="anchor" id="line-142"></span><ul><li><p class="line862">Koji 通过 -p 标志支持配置文件。我们定义一个叫做 'cbs' 的配置文件（这就是你为什么可以使用这个很方便的命令：<tt class="backtick">/usr/bin/cbs</tt>） <span class="anchor" id="line-143"></span></li><li>要从普通的koji命令行上使用配置文件，你可以运行： <span class="anchor" id="line-144"></span></li></ul><p class="line867"><span class="anchor" id="line-145"></span><pre><span class="anchor" id="line-1-10"></span>   koji -p cbs list-tags</pre><span class="anchor" id="line-146"></span><span class="anchor" id="line-147"></span><ul><li>你也可以同时保留 Fedora 及其它 koji 实例的设置。 <span class="anchor" id="line-148"></span></li><li>不应用 -p 时所采用的服务器应该在 [koji] 部份内指定，因为这是缺省设置。 <span class="anchor" id="line-149"></span><span class="anchor" id="line-150"></span></li></ul><p class="line867">
<h1 id="A.2BXfJ35ZXumJg-">已知问题</h1>
<span class="anchor" id="line-151"></span><span class="anchor" id="line-152"></span><ul><li>现时仍未启用创建 git.c.o 的支持。 <span class="anchor" id="line-153"></span><span class="anchor" id="line-154"></span></li></ul><p class="line867">
<h1 id="A.2BWRaQ6I.2FeftM-">外部连结</h1>
<span class="anchor" id="line-155"></span><span class="anchor" id="line-156"></span><p class="line862">官方文档：<a class="https" href="https://fedoraproject.org/wiki/Koji">https://fedoraproject.org/wiki/Koji</a> <span class="anchor" id="line-157"></span><span class="anchor" id="line-158"></span><p class="line867"><small>Translation of revision 35</small> <span class="anchor" id="line-159"></span><span class="anchor" id="bottom"></span></div>
</div>
<hr>
2023-09-11 07:23
</body>
</html>
